#Python section
from odict import OrderedDict

#Panda section
from panda3d.core import *

#DMK section
from DMKManagerBase import DMKManagerBase
from DMKVar import DMKVar

class DMKDobjShaderManager(DMKManagerBase):
        """Manager for Dobj Shaders"""

        def __init__(self):
            DMKManagerBase.__init__(self)
            self.myShader = None
            self.np = None
            self.shaderlist = ['AlphaMap']
            self.vardictionnary["Shader"]= DMKVar("Main","Enum",self.shaderlist,"AlphaMap",True,None,None)

        def Initialize(self,np):
            if self.GetValueByProperty("isActive") == True:
                self.np = np
                self.myShader = self.LoadShader()
                texture = loader.loadTexture(Filename.fromOsSpecific("PATH\\alpha_map.jpg")) 
                self.np.setShaderOff()
                self.np.setLightOff()
                self.np.setShader(self.myShader)
                self.np.set_shader_input("alphamaptexture",texture)
                taskMgr.add(self.UpdateShaderTask,"UpdateShaderTask"+self.np.getName())

        def LoadShader(self):
            shadervs = "PATH"
            strVertexShader = shadervs  + "AlphaMap_VS.glsl"
            strFragmentShader = shadervs  + "AlphaMap_FS.glsl"
            v = open(strVertexShader).read()
            f = open(strFragmentShader).read()
            return Shader.make(Shader.SLGLSL, v, f)

        def UpdateShaderTask(self,task):
            self.np.set_shader_input("time",task.time)
            return task.cont

        def Stop(self):
            if self.np is not None:
                taskMgr.remove("UpdateShaderTask"+self.np.getName())
            if self.myShader is not None:
                self.myShader = None