#Panda section
from direct.gui.OnscreenImage import OnscreenImage
from panda3d.core import TransparencyAttrib,CardMaker

#DMK section
from DMKVar import DMKVar
from Dobj import Dobj

class DMKQuad3D(Dobj):
    """Class to manage the Quad3D"""

    def __init__(self, displayname, runmode, dbjid):
        Dobj.__init__(self,displayname, runmode, dbjid)
        self.vardictionnary["DobjType"].value = "DMKQuad3D"
      
    def Initialize(self):
        """Initialize the Quad3D"""
        if Dobj.Initialize(self) != False:
            cm = CardMaker("plane")
            cm.setFrame(-1, 1, -1, 1)
            cm.setHasNormals(True)
            self.np = render.attachNewNode(cm.generate())
            self.np.setPos(self.GetValueByProperty("Position"))
            self.np.setHpr(self.GetValueByProperty("Hpr"))
            self.np.setScale(self.GetValueByProperty("Scale"))
            self.np.setTwoSided(True)
            self.np.setDepthOffset(-1) #Required for the shadows to be properly applied on the Quad
            self.DMKMaterialManager.Initialize(self.np,self.DemoAssetManager)   #All texture / material are managed in the DMKMaterialManager (contrary to Quad2D)
            self.InitializeDobjLightManager()
            self.InitializeShaderManager()
            self.InitializeControllers()

    def Stop(self):
        self.DMKDobjPhysicsManager.Stop()
        if self.PhysicsNode is not None:
            self.world.removeRigidBody(self.PhysicsNode)
            self.PhysicsNode=None
        if self.DMKInstanceManager.GetValueByProperty("isActive")==True:
            self.DMKInstanceManager.Stop()
        return super(DMKQuad3D, self).Stop()